# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Provides/Requires filtering is different from rpm 4.9 onwards
%global rpm49 %(rpm --version | perl -p -e 's/^.* (\\d+)\\.(\\d+).*/sprintf("%d.%03d",$1,$2) ge 4.009 ? 1 : 0/e' 2>/dev/null || echo 0)

Name:		perl-Test-Harness
Epoch:		1
Version:	3.42
Release:	1.%{__distinit}%{__distvers}
Summary:	Run Perl standard test scripts with statistics
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/Test-Harness/
Source0:	http://search.cpan.org/CPAN/authors/id/L/LE/LEONT/Test-Harness-%{version}.tar.gz
Source14:	App-Cpan-14.pm
Source15:	App-Cpan-15.pm
BuildArch:	noarch
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
# Run-time:
BuildRequires:	perl(base)
BuildRequires:	perl(Benchmark)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Config)
BuildRequires:	perl(constant)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(Getopt::Long)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IO::Select)
BuildRequires:	perl(POSIX)
BuildRequires:	perl(strict)
BuildRequires:	perl(Text::ParseWords)
BuildRequires:	perl(warnings)
# Optional run-time:
BuildRequires:	perl(Encode)
# Keep Pod::Usage 1.12 really optional
BuildRequires:	perl(Term::ANSIColor)
BuildRequires:	perl(Time::HiRes)
# Tests:
BuildRequires:	perl(Data::Dumper)
# Dev::Null bundled for bootstrap
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(IO::File)
BuildRequires:	perl(lib)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(Test::Builder::Module)
BuildRequires:	perl(Test::More)
# Optional tests:
BuildRequires:	perl(CPAN::Meta::YAML)
BuildRequires:	perl(File::Temp)
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

# TAP::Harness was packaged separately for some time
Obsoletes:	perl-TAP-Harness < %{version}-%{release}
Provides:	perl-TAP-Harness = %{version}-%{release}

# Filter example dependencies
%global __requires_exclude_from ^%{_datadir}/doc
%global __provides_exclude_from ^%{_datadir}/doc
%global __provides_exclude ^perl\\(ExtUtils::MakeMaker::_version|Harness::Hook|Local::Null::Logger\\)$

%description
This package allows tests to be run and results automatically aggregated and
output to STDOUT.

Although, for historical reasons, the Test-Harness distribution takes its name
from this module it now exists only to provide TAP::Harness with an interface
that is somewhat backwards compatible with Test::Harness 2.xx. If you're
writing new code consider using TAP::Harness directly instead.

%prep
%setup -q -n Test-Harness-%{version}

# Filter bogus provides/requires if we don't have rpm ≥ 4.9
%if ! %{rpm49}
%global provfilt /bin/sh -c "%{__perl_provides} | grep -Ev '^perl[(](ExtUtils::MakeMaker::_version|Harness::Hook|Local::Null::Logger)[)]'"
%global __perl_provides %{provfilt}
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -Ev '^perl[(](Harness::Hook|lib|Test::More|Test::WWW::Mechanize)[)]'"
%global __perl_requires %{reqfilt}
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

# Fedora 14 has App::CPAN here instead of perl-CPAN (#854577)
%if "%{?fedora}" == "14"
install -p -m 644 %{SOURCE14} %{buildroot}%{perl_vendorlib}/App/Cpan.pm
%endif
# Fedora 15 has App::CPAN here instead of perl-CPAN (#854577)
%if "%{?fedora}" == "15"
install -p -m 644 %{SOURCE15} %{buildroot}%{perl_vendorlib}/App/Cpan.pm
%endif

%check
make test

%files
%doc Changes Changes-2.64 examples/ README
%{_bindir}/prove
%{perl_vendorlib}/App/
%dir %{perl_vendorlib}/TAP/
%{perl_vendorlib}/TAP/Base.pm
%{perl_vendorlib}/TAP/Formatter/
%dir %{perl_vendorlib}/TAP/Harness/
%{perl_vendorlib}/TAP/Harness.pm
%doc %{perl_vendorlib}/TAP/Harness/Beyond.pod
%{perl_vendorlib}/TAP/Harness/Env.pm
%{perl_vendorlib}/TAP/Object.pm
%{perl_vendorlib}/TAP/Parser/
%{perl_vendorlib}/TAP/Parser.pm
%dir %{perl_vendorlib}/Test/
%doc %{perl_vendorlib}/Test/HACKING.pod
%{perl_vendorlib}/Test/Harness.pm
%{_mandir}/man1/prove.1*
%{_mandir}/man3/App::Prove.3*
%{_mandir}/man3/App::Prove::State.3*
%{_mandir}/man3/App::Prove::State::Result.3*
%{_mandir}/man3/App::Prove::State::Result::Test.3*
%{_mandir}/man3/TAP::Base.3*
%{_mandir}/man3/TAP::Formatter::Base.3*
%{_mandir}/man3/TAP::Formatter::Color.3*
%{_mandir}/man3/TAP::Formatter::Console.3*
%{_mandir}/man3/TAP::Formatter::Console::ParallelSession.3*
%{_mandir}/man3/TAP::Formatter::Console::Session.3*
%{_mandir}/man3/TAP::Formatter::File.3*
%{_mandir}/man3/TAP::Formatter::File::Session.3*
%{_mandir}/man3/TAP::Formatter::Session.3*
%{_mandir}/man3/TAP::Harness.3*
%{_mandir}/man3/TAP::Harness::Beyond.3*
%{_mandir}/man3/TAP::Harness::Env.3*
%{_mandir}/man3/TAP::Object.3*
%{_mandir}/man3/TAP::Parser.3*
%{_mandir}/man3/TAP::Parser::Aggregator.3*
%{_mandir}/man3/TAP::Parser::Grammar.3*
%{_mandir}/man3/TAP::Parser::Iterator.3*
%{_mandir}/man3/TAP::Parser::Iterator::Array.3*
%{_mandir}/man3/TAP::Parser::Iterator::Process.3*
%{_mandir}/man3/TAP::Parser::Iterator::Stream.3*
%{_mandir}/man3/TAP::Parser::IteratorFactory.3*
%{_mandir}/man3/TAP::Parser::Multiplexer.3*
%{_mandir}/man3/TAP::Parser::Result.3*
%{_mandir}/man3/TAP::Parser::Result::Bailout.3*
%{_mandir}/man3/TAP::Parser::Result::Comment.3*
%{_mandir}/man3/TAP::Parser::Result::Plan.3*
%{_mandir}/man3/TAP::Parser::Result::Pragma.3*
%{_mandir}/man3/TAP::Parser::Result::Test.3*
%{_mandir}/man3/TAP::Parser::Result::Unknown.3*
%{_mandir}/man3/TAP::Parser::Result::Version.3*
%{_mandir}/man3/TAP::Parser::Result::YAML.3*
%{_mandir}/man3/TAP::Parser::ResultFactory.3*
%{_mandir}/man3/TAP::Parser::Scheduler.3*
%{_mandir}/man3/TAP::Parser::Scheduler::Job.3*
%{_mandir}/man3/TAP::Parser::Scheduler::Spinner.3*
%{_mandir}/man3/TAP::Parser::Source.3*
%{_mandir}/man3/TAP::Parser::SourceHandler.3*
%{_mandir}/man3/TAP::Parser::SourceHandler::Executable.3*
%{_mandir}/man3/TAP::Parser::SourceHandler::File.3*
%{_mandir}/man3/TAP::Parser::SourceHandler::Handle.3*
%{_mandir}/man3/TAP::Parser::SourceHandler::Perl.3*
%{_mandir}/man3/TAP::Parser::SourceHandler::RawTAP.3*
%{_mandir}/man3/TAP::Parser::YAMLish::Reader.3*
%{_mandir}/man3/TAP::Parser::YAMLish::Writer.3*
%{_mandir}/man3/Test::HACKING.3*
%{_mandir}/man3/Test::Harness.3*

%changelog
* Tue Mar 20 2018 Paul Howarth <paul@city-fan.org> - 1:3.42-1
- Update to 3.42
  - Enable rulesfile.t to run in core

* Wed Feb 28 2018 Paul Howarth <paul@city-fan.org> - 1:3.41-1
- Update to 3.41
  - Return handle for pipes and sockets (GH#58)
  - TAP v13 plan allows trailing whitespace
  - prove: Add a --statefile=<path> option to customize the .prove file
  - Avoid non-deterministic source handling, make a SourceHandler tie an error
  - Fix and simplify MSWin32 colorization
  - Fix file source handler to accept single extensions option
  - Spelling fixes
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Sun Jun  4 2017 Paul Howarth <paul@city-fan.org> - 1:3.39-1
- Perl 5.26 rebuild

* Thu Apr  6 2017 Paul Howarth <paul@city-fan.org> - 3.39-1
- Update to 3.39
  - Make tests pass when PERL_USE_UNSAFE_INC=0
- Drop now-redundant BuildRoot: and Group: tags

* Tue Mar 14 2017 Paul Howarth <paul@city-fan.org> - 3.38-1
- Update to 3.38
  - Set PERL_USE_UNSAFE_INC when running tests using Test::Harness
  - Avoid loading optional modules from . in prove

* Wed Aug  3 2016 Paul Howarth <paul@city-fan.org> - 3.36-367
- Avoid loading optional modules from default . (CVE-2016-1238)

* Tue Jul 26 2016 Paul Howarth <paul@city-fan.org> - 3.36-366
- Fix FTBFS when perl is not in the minimal buildroot
- BR: perl-generators where available
- Simplify find command using -delete
- Prefer %%global over %%define

* Fri Jan  1 2016 Paul Howarth <paul@city-fan.org> - 3.36-1
- Update to 3.36
  - Accept YAML with trailing whitespace in header
  - Stop bundling Test::More for testing

* Tue Jun 23 2015 Paul Howarth <paul@city-fan.org> - 3.35-2
- Fedora 14 and 15 have App::CPAN here instead of perl-CPAN (#854577)

* Thu Jan 15 2015 Paul Howarth <paul@city-fan.org> - 3.35-1
- Update to 3.35
  - Fix prove --version to actually print the version (CPAN RT#101216)
  - Add --version to usage message (CPAN RT#101215)

* Fri Nov  7 2014 Paul Howarth <paul@city-fan.org> - 3.34-1
- Update to 3.34
  - Various documentation fixes
  - Enable printing CPU times spent per test

* Thu Jun 12 2014 Paul Howarth <paul@city-fan.org> - 3.32-1
- Update to 3.32
  - Remove harness_class from argument hash in TAP::Harness::Env

* Tue Jun 10 2014 Paul Howarth <paul@city-fan.org> - 3.31-1
- Update to 3.31
  - Implement external rulesfile for TAP::Harness
  - Add harness_class argument to TAP::Harness::Env
  - Make prove respect environmental variables
    (https://github.com/Perl-Toolchain-Gang/Test-Harness/issues/28)

* Wed Nov 13 2013 Paul Howarth <paul@city-fan.org> - 3.30-1
- Update to 3.30
  - Respect PERL5LIB in tainting source handler test
  - Use base instead of parent: this dist is used for testing all other
    modules, so it should avoid having any non-core prerequisites; having
    parent as a prereq leads to a circular dependency of
    parent -> Test::More -> Test::Harness
  - Various POD fixes
  - Don't localize all of %%ENV in harness.t
  - Give TAP::Harness::Beyond a unique NAME
- This release by LEONT -> update source URL

* Fri Oct 11 2013 Paul Howarth <paul@city-fan.org> - 3.29-2
- Obsolete/provide perl-TAP-Harness

* Fri Oct 11 2013 Paul Howarth <paul@city-fan.org> - 3.29-1
- Import from Fedora
- Update to 3.29

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.28-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 12 2013 Petr Pisar <ppisar@redhat.com> - 3.28-2
- Perl 5.18 rebuild

* Fri May 03 2013 Petr Pisar <ppisar@redhat.com> - 3.28-1
- 3.28 bump

* Thu May 02 2013 Petr Pisar <ppisar@redhat.com> - 3.27-1
- 3.27 bump

* Mon Mar 18 2013 Petr Pisar <ppisar@redhat.com> - 3.26-1
- Specfile autogenerated by cpanspec 1.78
